import os, sys, math, string, traceback, types, keyword, __builtin__
from string import replace, lower, split, atoi, lstrip, rstrip, \
     strip

class Interpreter:

    def __init__(self, name = "<console>", namespace = None):

        self.name = name

        if namespace:
            self.locals = namespace
        else:
            self.locals = {}

    def push(self, lines):
        
        try:
            #
            # compile 
            try:
                tmp = compile(lines, self.name, 'eval')
                code = compile(lines, self.name, 'single')
            except SyntaxError:
                code = compile(lines, self.name, 'exec')
                
            #
            # execute
            exec code in self.locals

        except:
            self.showtraceback()

    def showsyntaxerror(self):
        # stolen from "idle" by  G. v. Rossum
        type, value, sys.last_traceback = sys.exc_info()
        sys.last_type = type
        sys.last_value = value
        filename = self.name
        if filename and type is SyntaxError:
            # Work hard to stuff the correct filename in the exception
            try:
                msg, (dummy_filename, lineno, offset, line) = value
            except:
                # Not the format we expect; leave it alone
                pass
            else:
                # Stuff in the right filename
                try:
                    # Assume SyntaxError is a class exception
                    value = SyntaxError(msg, (filename, lineno, offset, line))
                except:
                    # If that failed, assume SyntaxError is a string
                    value = msg, (filename, lineno, offset, line)
                    
        sys.stderr.write(string.join(traceback.format_exception_only(type, value))+'\n')


    def showtraceback(self):
        if type( sys.exc_value) == types.InstanceType:
            args = sys.exc_value.args
        else:
            args = sys.exc_value

        traceback.print_tb( sys.exc_traceback.tb_next, None)
        self.showsyntaxerror()  

